function varargout=feval3D03(varargin)
  % Th=fc_simesh.demos.feval3D01('geofile','cylinder3holes','N',10,'verbose',2,'MshFileVersion','4.1','force',true);
  fprintf('************************************\n')
  fprintf('  Running %s function\n',mfilename())
  fprintf('************************************\n')
  [Th,verbose]=fc_simesh.demos.setMesh3D(varargin{:});
  
  f={@(x,y,z) cos(2*x).*sin(3*y)-z, @(x,y,z) cos(3*x).*sin(4*y)+z};
  
  g={@(q) cos(2*q(1,:)).*sin(3*q(2,:))-q(3,:), @(x,y,z) cos(3*x).*sin(4*y)+z};

  if verbose,fprintf('*** Computing functions on mesh\n');end
  V1=Th.feval(f);
  V2=Th.feval(g);
  
  if verbose,fprintf('*** Check results\n');end
  res=0;
  res=res+ ~( all(size(V1)==[Th.nq,2]) && all(size(V2)==[Th.nq,2]) );
  if verbose, if (res==1),    fprintf('  Test 0: failed with dimensions\n');else fprintf('  Test 0: OK\n');end;end
  E=sum(size(V1)~=size(V2)); % return 0 if same size
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with size(V1)=[%s] and size(V2)=[%s]\n',num2str(size(V1)),num2str(size(V2)));else fprintf('  Test 1: OK\n');end;end
  if E==0
    E=norm(V1-V2,Inf);
    res=res+(E >1e-15);
    if verbose, if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  end
  if res>0,error('demo % failed',mfilename()');end
  if nargout==1,varargout{1}=Th;end
end


